package benchmark.helpClasses;

public class TimeBoundedApplication extends Thread
{

	public static final double STOP_TIME_VALUE = -1;

	public long beginTime;

	public double endTime;

	/**
	 * max. number millis per thread
	 */
	protected final int maxNumberMillis;

	public TimeBoundedApplication(final int sec)
	{
		this.maxNumberMillis = sec * 1000;
	}

	/**
	 * Returns the required time in seconds. TestSearchTreeAlgorithm.STOP_TIME_VALUE iff the algorithm was stopped
	 * 
	 * @return
	 */
	public double getTime()
	{
		return this.endTime;
	}

	/**
	 * Returns true iff the algorithm was stopped. (due to exceeding the time limit)
	 */
	public boolean isStopped()
	{
		return this.endTime == TimeBoundedApplication.STOP_TIME_VALUE;
	}

	public void runAlgorithm()
	{
		this.beginTime = System.currentTimeMillis();
		this.start();
		int sleep = 10;
		int step = 0;

		int sum = 0;
		while (this.getState().equals(Thread.State.RUNNABLE))
		{
			try
			{
				Thread.sleep(sleep);
				sum += sleep;
				// System.out.println("slept:" + sleep + "ms (sum:" + sum +
				// ",elapTime:" + (System.currentTimeMillis() - beginTime) +
				// ")");
				if (sleep <= 500)
				{
					if (step == 15)
					{
						step = 0;
						sleep = sleep << 1;
					} else
					{
						step++;
					}
				}
			} catch (final InterruptedException e)
			{
				e.printStackTrace();
			}
			if ((System.currentTimeMillis() - this.beginTime) > this.maxNumberMillis)
			{
				this.stop();
				this.endTime = TimeBoundedApplication.STOP_TIME_VALUE;
				break;
			}
		}
	}
}