package commandLineOptionsHelpClasses;

public abstract class CLOption<T>
{
	private final int index;
	private final String label;
	protected final T o;
	private final boolean requiredArg;
	protected final boolean v;

	public CLOption(final T t, final int index, final boolean verbose, final boolean requiredArg)
	{
		this(t, "index(" + index + ")", index, verbose, requiredArg);
	}

	public CLOption(final T t, final String label, final boolean verbose, final boolean requiredArg)
	{
		this(t, label, -1, verbose, requiredArg);
	}

	CLOption(final T t, final String label, final int index, final boolean verbose, final boolean requiredArg)
	{
		this.o = t;
		this.label = label;
		this.v = verbose;
		this.index = index;
		this.requiredArg = requiredArg;
	}

	private void noArgument()
	{
		System.out.println("no argument for " + this.label + (this.index >= 0 ? "(" + this.index + ")" : "") + ", set it to its standard value:"
				+ this.o.toString());
	}

	protected abstract void setObjectValue(String string);

	public void setValue(final String[] args)
	{
		if (this.index >= 0)// standard!!!
		{
			this.setValueFromIndex(args, this.index);
		} else
		{
			boolean t = false;
			for (int i = 0; i < args.length; i++)
			{
				if (args[i].equalsIgnoreCase("-" + this.label))
				{
					this.setValueFromIndex(args, i + 1);
					t = true;
					break;
				}
			}
			if (this.requiredArg && !t)
			{
				this.setValueFromIndex(args, -1);// throws an exception
			}

			if (!t && this.v)
			{
				this.noArgument();
			}
		}
	}

	private void setValueFromIndex(final String[] args, final int i)
	{
		if (this.requiredArg && ((i < 0) || (i > (args.length - 1))))
			throw new IllegalAccessError("argument " + this.label + " is required but unspecified!");

		this.setObjectValue(args[i]);
		if (this.v)
		{
			System.out.println("set " + this.label + " to:" + this.o.toString());
		}
	}
}