package distanceFunction;

import java.util.Vector;

public interface ReadOnlyViewOnSymmetricDiscreteDistanceFunction
{

	/**
	 * Returns d(i,j).
	 * 
	 * @param i index
	 * @param j index
	 * @return
	 */
	public abstract int get(int i, int j);

	/**
	 * Computes the similarity of two distance functions under the l1-norm.
	 */
	public abstract int getDistance(SymmetricDiscreteDistanceFunction dis);

	public abstract int getMaxValue();

	public abstract int getNoOfElements();

	/**
	 * Check whether the distances between the given indices form a conflict or not.
	 * 
	 * @param indices , such that d_indices[0]_indices[1]=max
	 * @return
	 */
	public abstract int[] isConflict(int i, int j, int l);

	public abstract boolean isConflict(int[] indices);

	public abstract boolean isDeletedData(int i);

	public abstract boolean isUltrametric();

	public abstract boolean isUltrametric(Vector<Integer> indices);

}