package distanceFunction;

import java.util.Arrays;
import java.util.Iterator;

import com.zaxxer.sparsebits.SparseBitSet;

import dataStructures.IntTupel;

public class SymmetricSparseBitSetDistanceFunction extends SymmetricBooleanDistanceFunction
{
	private final SparseBitSet[] distance;

	// private SymmetricSparseBitSetDistanceFunction(final boolean[][] arr)
	// {
	// super(arr.length + 1);
	// distance = arr;
	// }

	public SymmetricSparseBitSetDistanceFunction(final int n)
	{
		super(n);
		this.distance = new SparseBitSet[n - 1];
		// for (int i = n - 1; i > 0; i--)
		// {
		// distance[n - 1 - i] = new SparseBitSet(i);// new boolean[i];
		// }
	}

	// @Override
	// public SymmetricSparseBitSetDistanceFunction clone()
	// {
	// final boolean[][] copyArr = new boolean[distance.length][];
	// for (int i = 0; i < copyArr.length; i++)
	// {
	// copyArr[i] = distance[i].clone();
	// }
	// return new SymmetricSparseBitSetDistanceFunction(copyArr);
	// }

	public Iterable<IntTupel> getIndicesWithSetValue()
	{
		class T implements Iterable<IntTupel>
		{
			@Override
			public Iterator<IntTupel> iterator()
			{
				class Tmp implements Iterator<IntTupel>
				{
					private int iE;
					private int jE;

					public Tmp()
					{
						this.iE = -1;
						this.increase_iE();
					}

					@Override
					public boolean hasNext()
					{
						while (this.iE < (SymmetricSparseBitSetDistanceFunction.this.getNoOfElements() - 1))
						{
							final int next = SymmetricSparseBitSetDistanceFunction.this.distance[this.iE].nextSetBit(this.jE - (this.iE + 1));
							if (next >= 0)
							{
								this.jE = next + this.iE + 1;
								return true;
							}
							this.increase_iE();
						}
						return false;
					}

					public void increase_iE()
					{
						do
						{
							this.iE++;
						} while ((this.iE < (SymmetricSparseBitSetDistanceFunction.this.getNoOfElements() - 1))
								&& (SymmetricSparseBitSetDistanceFunction.this.distance[this.iE] == null));
						this.jE = this.iE + 1;
					}

					@Override
					public IntTupel next()
					{
						if (this.hasNext())
						{
							final IntTupel r = new IntTupel(this.iE, this.jE);
							if (this.jE < (SymmetricSparseBitSetDistanceFunction.this.getNoOfElements() - 1))
							{
								this.jE++;
							} else
							{
								this.increase_iE();
							}
							return r;
						}
						return null;
					}

					@Override
					public void remove()
					{
						throw new IllegalAccessError();
					}

				}
				;
				return new Tmp();
			}

		}
		;
		return new T();
	}

	@Override
	boolean getInternal(final int i, final int j)
	{
		if (this.distance[i] == null)
			return false;
		return this.distance[i].get(j);
	}

	@Override
	public int hashCode()
	{
		return Arrays.deepHashCode(this.distance) * this.getNoOfElements();
	}

	@Override
	void setInternal(final int i, final int j, final boolean value)
	{
		if (this.distance[i] == null)
		{
			this.distance[i] = new SparseBitSet(j);
		}

		this.distance[i].set(j, value);
	}
}
