package benchmark.helpClasses.timeBoundedApplications;

import solver.hierarchicalClustering.HierarchicalClusteringSolver;
import solver.hierarchicalClustering.SearchTreeSolver;
import benchmark.helpClasses.TimeBoundedApplication;
import distanceFunction.SymmetricDiscreteDistanceFunction;

public class TimeBoundedSearchTreeAlgorithm extends TimeBoundedApplication
{
	private final boolean interleaveLP;

	private final boolean interleaving;

	private long iter;

	private final boolean kernelization;

	public boolean solveFlag;

	private final SearchTreeSolver solver;

	public TimeBoundedSearchTreeAlgorithm(final SymmetricDiscreteDistanceFunction dist, final int param, final boolean inter, final boolean kernel,
			final boolean interleaveLP)
	{
		this(dist, param, inter, kernel, interleaveLP, 60 * 30);
	}

	public TimeBoundedSearchTreeAlgorithm(final SymmetricDiscreteDistanceFunction dist, final int param, final boolean interleaveDR,
			final boolean iniKernelization, final boolean interleaveLP, final int sec)
	{
		super(sec);
		this.kernelization = iniKernelization;
		this.interleaving = interleaveDR;
		this.interleaveLP = interleaveLP;
		this.solver = new SearchTreeSolver(dist, param);
	}

	public long getNumberOfIter()
	{
		return this.iter;
	}

	public HierarchicalClusteringSolver getSolver()
	{
		return this.solver;
	}

	@Override
	public void run()
	{
		final long begin = System.currentTimeMillis();
		this.solveFlag = this.solver.solve(this.kernelization, this.interleaving, this.interleaveLP);
		this.endTime = (System.currentTimeMillis() - begin) / 1000d;
		this.iter = this.solver.getNumberOfRecursiveSteps();
	}
}