package benchmark.realWorldData;

import hcUtils.Utils;

import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Arrays;

import distanceFunction.SymmetricDiscreteDistanceFunction;

public class WriteInstances
{
	private static String getFileName(final String fileName, final float c, final int M)
	{
		final NumberFormat nf = new DecimalFormat("0000");
		String name = "nr_";

		final int bindex = fileName.indexOf("nr_") + 3;
		final int eIndex = fileName.indexOf("_", bindex);
		name += nf.format(Integer.parseInt(fileName.substring(bindex, eIndex)));

		name += "_n_" + WriteInstances.getN(fileName, "size_");

		name += "_c_" + c;
		name += "_M_" + M;
		return "c=" + c + "_M=" + M + "/" + name + ".dat";
	}

	public static int getN(final String fileName, final String prefix)
	{
		final int bindex = fileName.indexOf(prefix) + prefix.length();
		final int eIndex = fileName.indexOf("_", bindex);
		final String n = fileName.substring(bindex, eIndex);
		return Integer.parseInt(n);
	}

	public static void main(final String[] args)
	{
		final String rawPath = "raw/";
		final String filePath = "/home/sepphar/test/";
		final File rawDataFolder = new File(filePath + rawPath);
		System.out.println(rawDataFolder.isDirectory());
		final String[] fileList = rawDataFolder.list();
		Arrays.sort(fileList);

		final float[] cArr = { 0.33f, 0.5f, 0.66f, 0.75f };

		for (int M = 2; M <= 3; M++)
		{
			for (final float c : cArr)
			{
				final float fact = 1f - c;

				for (final String fileName : fileList)
				{
					// if ( i++ > 10 )
					// break;
					if (fileName.endsWith("cm") && (WriteInstances.getN(fileName, "size_") <= 90))
					{
						// i++;
						final SymmetricDiscreteDistanceFunction dist = Utils.read_cos(filePath + rawPath + fileName, M, fact);
						try
						{
							dist.writeToFile(filePath + WriteInstances.getFileName(fileName, c, M), null);
						} catch (final IOException e)
						{
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}
				}
			}
		}
	}
}
