package dataReductionRules;

public abstract class AdvancedRule implements RuleInterface
{
	private int applicationCounter = 0;

	private final int interleavingCons;

	public AdvancedRule(final int interleavingConst)
	{
		this.interleavingCons = interleavingConst;
	}

	protected abstract boolean performReductionRule(ChangeLogger instance) throws UnsolvableException;

	@Override
	public final boolean performRule(final ChangeLogger instance) throws UnsolvableException
	{
		if ((this.applicationCounter++ % this.interleavingCons) == 0)
			return this.performReductionRule(instance);
		return false;
	}
}
