package dataReductionRules;

//import java.util.Vector;

import solver.hierarchicalClustering.ModificationStatistic;
import distanceFunction.SymmetricDiscreteDistanceFunction;

/**
 * 
 * set blocks on non-conflicts
 * 
 * @version 1.0
 * 
 */
public class Rule4 extends AdvancedRule implements Cloneable
{
	public Rule4(final int interleavingConst)
	{
		super(interleavingConst);
	}

	@Override
	public boolean performReductionRule(final ChangeLogger solver) throws UnsolvableException
	{
		final boolean out = false;

		// final Vector<int[]> conflictArrs =
		// solver.getConflictStorage().getConflicts();

		final SymmetricDiscreteDistanceFunction distanceFunction = solver.getDistanceFunction();
		final ModificationStatistic modStat = solver.getModStatistic();
		{// traverse all triples (not only conflicts)

			for (int i = 0; i < distanceFunction.getNoOfElements(); i++)
			{
				for (int j = i + 1; j < distanceFunction.getNoOfElements(); j++)
				{

					for (int l = j + 1; l < distanceFunction.getNoOfElements(); l++)
					{
						final int d_i_j = distanceFunction.get(i, j);
						final int d_i_l = distanceFunction.get(i, l);
						final int d_j_l = distanceFunction.get(j, l);

						if ((d_i_j < d_i_l) && (d_i_j < d_j_l) && (d_i_l == d_j_l))
						{// not a conflict
							// and ij is minimum
							// edge
							if (!modStat.isIncreasePossible(i, j))
							{
								if (!modStat.isDecreasePossible(j, l))
								{
									modStat.avoidDecrease(i, l);
								}
								if (!modStat.isIncreasePossible(j, l))
								{
									modStat.avoidIncrease(i, l);
								}
								if (!modStat.isDecreasePossible(i, l))
								{
									modStat.avoidDecrease(j, l);
								}
								if (!modStat.isIncreasePossible(j, l))
								{
									modStat.avoidIncrease(i, l);
								}
							}
						} else if ((d_j_l < d_i_j) && (d_j_l < d_i_l) && (d_i_j == d_i_l))
						{// not a
							// conflict and
							// jl is minimum
							// edge
							if (!modStat.isIncreasePossible(j, l))
							{
								if (!modStat.isDecreasePossible(i, l))
								{
									modStat.avoidDecrease(i, j);
								}
								if (!modStat.isIncreasePossible(i, l))
								{
									modStat.avoidIncrease(i, j);
								}
								if (!modStat.isDecreasePossible(i, j))
								{
									modStat.avoidDecrease(i, l);
								}
								if (!modStat.isIncreasePossible(i, j))
								{
									modStat.avoidIncrease(i, l);
								}
							}
						} else if ((d_i_l < d_i_j) && (d_i_l < d_j_l) && (d_i_j == d_j_l))
						{// not a
							// conflict and
							// il is minimum
							// edge
							if (!modStat.isIncreasePossible(i, l))
							{
								if (!modStat.isDecreasePossible(j, l))
								{
									modStat.avoidDecrease(i, j);
								}
								if (!modStat.isIncreasePossible(j, l))
								{
									modStat.avoidIncrease(i, j);
								}
								if (!modStat.isDecreasePossible(i, j))
								{
									modStat.avoidDecrease(j, l);
								}
								if (!modStat.isIncreasePossible(i, j))
								{
									modStat.avoidIncrease(j, l);
								}
							}
						} else if ((d_i_j == d_i_l) && (d_i_l == d_j_l))
						{// not a conflict and all 3
							// edges equal
							if (!modStat.isIncreasePossible(i, j))
							{
								if (!modStat.isIncreasePossible(j, l))
								{
									modStat.avoidIncrease(i, l);
								}
								if (!modStat.isIncreasePossible(i, l))
								{
									modStat.avoidIncrease(j, l);
								}
							}
							if (!modStat.isIncreasePossible(j, l))
							{
								if (!modStat.isIncreasePossible(i, l))
								{
									modStat.avoidIncrease(i, j);
								}
							}
						}
					}
				}
			}
		}

		/*
		 * boolean out = false;
		 * 
		 * for (int i = 0; i < conflictEdge.getNoOfElements(); i++) { for (int j = i + 1; j < conflictEdge.getNoOfElements(); j++) { final boolean
		 * greater = conflictEdge.get(i, j) > solver.getParameterValue(); final boolean less = nonConflictEdge.get(i, j) > solver.getParameterValue();
		 * if ( (greater && less) || ((greater || less) && (solver.getParameterValue() == 0)) ) throw new UnsolvableExecption(); else if ( greater ) {
		 * // decrease d_i_j distanceFunction.increase(i, j, -1); solver.decreaseParameter();
		 * 
		 * if ( solver.modStatistic != null ) solver.modStatistic.avoidIncrease(i, j);
		 * 
		 * out = true; // update edge-counter arrs j--; } else if ( less ) { // increase distanceFunction.increase(i, j, 1);
		 * solver.decreaseParameter();
		 * 
		 * if ( solver.modStatistic != null ) solver.modStatistic.avoidDecrease(i, j);
		 * 
		 * out = true; // update edge-counter arrs j--; } } } // add statistic if ( solver.use_edge_statistic ) solver.edgeCounterStatistic = new
		 * EdgeCounterStastic(conflictEdge, nonConflictEdge); return out;
		 */

		return out;
	}

}
