package solver.approximationHClustPivot;

public class HcPivot
{

	public static int run_hclustpivot(final distanceFunction.SymmetricDiscreteDistanceFunction D, final int T)
	{
		int min = Integer.MAX_VALUE;
		distanceFunction.SymmetricDiscreteDistanceFunction z = null;
		for (int i = 0; i < T; ++i)
		{
			// copy D
			z = new distanceFunction.SymmetricDiscreteDistanceFunction(D);

			// run approximation
			final hclustpivot approx = new hclustpivot(z);
			approx.solve();

			// distance between z and D
			final int dist = solver.approximationHClustPivot.hcUtils.Utils.distance(z, D);

			// update min
			min = dist < min ? dist : min;
		}

		return min;
	}

}
