package solver.approximationHClustPivot;

public class HcPivotAndDR
{

	public static int run_hclustpivot_and_dd(final distanceFunction.SymmetricDiscreteDistanceFunction D, final int T)
	{
		final boolean verbose = false;
		if (verbose)
		{
			System.out.println("run approximation and dr3; number of runs: " + T);
		}
		int min = Integer.MAX_VALUE;
		distanceFunction.SymmetricDiscreteDistanceFunction z = null;
		for (int i = 0; i < T; ++i)
		{
			// copy D
			z = new distanceFunction.SymmetricDiscreteDistanceFunction(D);

			// run approximation
			final HClustPivotAndDataReduction approx = new HClustPivotAndDataReduction(z);
			approx.solve();

			// distance between z and D
			final int dist = solver.approximationHClustPivot.hcUtils.Utils.distance(z, D);

			// update min
			min = dist < min ? dist : min;
			// System.out.println(i+":"+min+ " ");
		}

		System.out.println();
		return min;
	}

}
