package solver.hierarchicalClustering;

import java.util.Arrays;

public class ConflictArr
{
	protected final int[] con;
	private final int hash;

	public ConflictArr(final int[] conflict)
	{
		if (conflict.length != 3)
			throw new IllegalAccessError();
		this.con = conflict;
		this.hash = Arrays.hashCode(this.con);
	}

	@Override
	public boolean equals(final Object obj)
	{
		if (!(obj instanceof ConflictArr))
			return false;
		final int[] conf2 = ((ConflictArr) obj).con;
		return (this.con[0] == conf2[0]) && (this.con[1] == conf2[1]) && (this.con[2] == conf2[2]);
	}

	@Override
	public int hashCode()
	{
		return this.hash;
	}

	@Override
	public String toString()
	{
		return "ConflictArr [con=" + Arrays.toString(this.con) + "]";
	}
}
